// --------------------------------------------------------
// myData.h
// Definition der Klasse MyData zur Verwaltung von 
// Objekte der Klasse Data und davon abgeleiteter Klassen.
// --------------------------------------------------------
#ifndef _MYDATA_
#define _MYDATA_

#include "data.h"

class MyData      // Container fr XData- und SData-Objekte
{
  private:
    enum { ARR_LENGTH = 100} ;
    Data *arrPtrData[ARR_LENGTH];
    int count,               // Anzahl Objekte 
        iCur;                // und Einfgeposition.
    int nextFreePos();       // Hilfsmethode: Liefert
                             // nchsten freien Platz.
  public:
    MyData();                              // Default-Konstruktor
    MyData( const MyData& src);            // Kopierkonstruktor
    ~MyData();                             // Destruktor
    MyData& operator=( const MyData& src); // Zuweisung

    void eraseAll();
    bool erase( double x);
    bool erase( const char* s);

    bool isEmpty() const { return count == 0; }
    bool insertX( double x);
    bool insertX();
    bool insertS( const char* s);
    bool insertS();

    void printData() const;
};

#endif  // _MYDATA_ 
